/////////////////////////////////////////////////////////////////////////////////
///
/// @copyright COSEDA Technologies GmbH. All rights reserved.		
///            (customizable in sca_modules.dtd)		
///
/////////////////////////////////////////////////////////////////////////////////
//
// Author        : COSIDE(R) netlister
// Tool User     :
// Editors email :
// Created On    :
// Last Modifier : $Author$
// Last Modified : $Date$
//
// SVN Status    : $Id$
// Status        : Unknown, use with caution!
//
////////////////////////////////////////////////////////////////////////////////

/** ============================ DO NOT EDIT THIS FILE! ========================
 *  = This file was automatically generated from an COSIDE schematic.
 *  = (recreate via: "cp_lfilter_tb.scaml")
 *  ============================================================================
 */

/// include submodules
#include "cp.h"
#include "lfilter.h"
#include <sca_basic_libraries/arithmetic_sc/mux2s_sc.h>
#include <sca_basic_libraries/logic_sc/not_sc.h>
#include <sca_basic_libraries/sources_sc/std_clock_sc.h>


#ifndef PLL_LIBPLL_CP_LFILTER_TB_H_
/// if this file is not included by the header keep implementation
#include "cp_lfilter_tb.h"
#define COSIDE_INCLUDE_IMPLEMENTATION
#endif

/// adds SystemC namespaces for user convenience
#include <systemc.h>
#include <systemc-ams.h>

/// explicitly use std::abs() in any cases
#include <cmath>
using std::abs;

namespace pll_namespace
{

/// component declarations
struct cp_lfilter_tb::components
{

    /// declare instance references for external access
    cp& i_cp;	/** Charge pump implementation */
    lfilter& i_lfilter;	/** Loop filter */
    mux2s_sc<bool>& i_mux2s_sc;	/** multiplexer with 2 inports controlled by signal */
    not_sc<bool>& i_not_sc;	/** NOT (bitwise) */
    std_clock_sc& i_std_clock_sc1;	/** clock source */
    std_clock_sc& i_std_clock_sc2;	/** clock source */

    /// declare node and signal references for external access
    sc_core::sc_signal<bool	 >& dn;
    sc_core::sc_signal<bool	 >& unnamedNet1;
    sca_tdf::sca_signal<double	 >& unnamedNet3;
    sca_tdf::sca_signal<double	 >& unnamedNet4;
    sca_tdf::sca_signal<double	 >& vctrl;

    /// component constructor
    components(
                  cp* i_cp_,
                  lfilter* i_lfilter_,
                  mux2s_sc<bool>* i_mux2s_sc_,
                  not_sc<bool>* i_not_sc_,
                  std_clock_sc* i_std_clock_sc1_,
                  std_clock_sc* i_std_clock_sc2_,
                  sc_core::sc_signal<bool	 >& dn_,
                  sc_core::sc_signal<bool	 >& unnamedNet1_,
                  sca_tdf::sca_signal<double	 >& unnamedNet3_,
                  sca_tdf::sca_signal<double	 >& unnamedNet4_,
                  sca_tdf::sca_signal<double	 >& vctrl_
               ) :
                  i_cp(*i_cp_),
                  i_lfilter(*i_lfilter_),
                  i_mux2s_sc(*i_mux2s_sc_),
                  i_not_sc(*i_not_sc_),
                  i_std_clock_sc1(*i_std_clock_sc1_),
                  i_std_clock_sc2(*i_std_clock_sc2_),
                  dn(dn_),
                  unnamedNet1(unnamedNet1_),
                  unnamedNet3(unnamedNet3_),
                  unnamedNet4(unnamedNet4_),
                  vctrl(vctrl_)
    {}

    /// component destructor
    ~components()
    {
        // delete instances
        delete &i_cp;
        delete &i_lfilter;
        delete &i_mux2s_sc;
        delete &i_not_sc;
        delete &i_std_clock_sc1;
        delete &i_std_clock_sc2;

        /// delete signals
        delete &dn;
        delete &unnamedNet1;
        delete &unnamedNet3;
        delete &unnamedNet4;
        delete &vctrl;
    }

};


#ifdef COSIDE_INCLUDE_IMPLEMENTATION


/////////////////////////////////////////////////////////////////////////////
/// architecture implementation (netlist)                                  //
/////////////////////////////////////////////////////////////////////////////

void cp_lfilter_tb::architecture()
{
    /////////////////////////////////////////////////////////////////////////
    /// generate nodes/signals - map to references and name                //
    /////////////////////////////////////////////////////////////////////////
    sc_core::sc_signal<bool	 >& dn(* new sc_core::sc_signal<bool	 >("dn"));
    sc_core::sc_signal<bool	 >& unnamedNet1(* new sc_core::sc_signal<bool	 >("unnamedNet1"));
    sca_tdf::sca_signal<double	 >& unnamedNet3(* new sca_tdf::sca_signal<double	 >("unnamedNet3"));
    sca_tdf::sca_signal<double	 >& unnamedNet4(* new sca_tdf::sca_signal<double	 >("unnamedNet4"));
    sca_tdf::sca_signal<double	 >& vctrl(* new sca_tdf::sca_signal<double	 >("vctrl"));


    /////////////////////////////////////////////////////////////////////////
    /// instantiate modules, assign parameter                              //
    /////////////////////////////////////////////////////////////////////////
    cp::params p_i_cp;
    p_i_cp.ts = 0;
    p_i_cp.vdd = 0;
    p_i_cp.current_up = 0;
    p_i_cp.current_dn = 0;
    p_i_cp.current_leak = 0;
    p_i_cp.mosfet_vth = 0;
    cp *i_cp;
    i_cp = new cp("i_cp", p_i_cp);
    // port binding see netlist section

    lfilter::params p_i_lfilter;
    p_i_lfilter.c1 = 1.0;
    p_i_lfilter.r2 = 1.0;
    p_i_lfilter.c2 = 1.0;
    p_i_lfilter.r3 = 1.0;
    p_i_lfilter.c3 = 1e-12;
    p_i_lfilter.third_order = false;
    lfilter *i_lfilter;
    i_lfilter = new lfilter("i_lfilter", p_i_lfilter);
    // port binding see netlist section

    mux2s_sc<bool>::params p_i_mux2s_sc;
    mux2s_sc<bool> *i_mux2s_sc;
    i_mux2s_sc = new mux2s_sc<bool>("i_mux2s_sc", p_i_mux2s_sc);
    // port binding see netlist section

    not_sc<bool> *i_not_sc;
    i_not_sc = new not_sc<bool>("i_not_sc");
    // port binding see netlist section

    std_clock_sc::params p_i_std_clock_sc1;
    p_i_std_clock_sc1.period = sca_time(500e-9, SC_SEC);
    p_i_std_clock_sc1.duty_cycle = 0.5;
    p_i_std_clock_sc1.start_time = sc_core::SC_ZERO_TIME;
    p_i_std_clock_sc1.posedge_first = true;
    std_clock_sc *i_std_clock_sc1;
    i_std_clock_sc1 = new std_clock_sc("i_std_clock_sc1", p_i_std_clock_sc1);
    // port binding see netlist section

    std_clock_sc::params p_i_std_clock_sc2;
    p_i_std_clock_sc2.period = sca_time(2e-6, SC_SEC);
    p_i_std_clock_sc2.duty_cycle = 0.5;
    p_i_std_clock_sc2.start_time = sc_core::SC_ZERO_TIME;
    p_i_std_clock_sc2.posedge_first = true;
    std_clock_sc *i_std_clock_sc2;
    i_std_clock_sc2 = new std_clock_sc("i_std_clock_sc2", p_i_std_clock_sc2);
    // port binding see netlist section


    /////////////////////////////////////////////////////////////////////////
    /// netlist section                                                    //
    /////////////////////////////////////////////////////////////////////////
    // i_cp (cp)
    i_cp -> dn(dn);
    i_cp -> icp(unnamedNet3);
    i_cp -> up(i_std_clock_sc1->clk_o);
    i_cp -> vcp(unnamedNet4);

    // i_lfilter (lfilter)
    i_lfilter -> icp(unnamedNet3);
    i_lfilter -> vcp(unnamedNet4);
    i_lfilter -> vctrl(vctrl);

    // i_mux2s_sc (mux2s_sc<bool>)
    i_mux2s_sc -> ctrl_i(i_std_clock_sc2->clk_o);
    i_mux2s_sc -> sc0_i(i_std_clock_sc1->clk_o);
    i_mux2s_sc -> sc1_i(unnamedNet1);
    i_mux2s_sc -> sc_o(dn);

    // i_not_sc (not_sc<bool>)
    i_not_sc -> sc0_i(i_std_clock_sc1->clk_o);
    i_not_sc -> sc_o(unnamedNet1);

    // i_std_clock_sc1 (std_clock_sc)

    // i_std_clock_sc2 (std_clock_sc)




    /////////////////////////////////////////////////////////////////////////
    /// initialize struct for external(e.g. tb) access                     //
    /////////////////////////////////////////////////////////////////////////
    c = new components(
                         i_cp,
                         i_lfilter,
                         i_mux2s_sc,
                         i_not_sc,
                         i_std_clock_sc1,
                         i_std_clock_sc2,
                         dn,
                         unnamedNet1,
                         unnamedNet3,
                         unnamedNet4,
                         vctrl
                       );

}


/////////////////////////////////////////////////////////////////////////////
/// constructor/destructor section                                         //
/////////////////////////////////////////////////////////////////////////////

/// constructor implementation
cp_lfilter_tb::cp_lfilter_tb(sc_core::sc_module_name, const params& pa) :
          /// naming ports for debugging
          p(pa)
{

    architecture();
}

/// destructor implementation
cp_lfilter_tb::~cp_lfilter_tb()
{

    /// delete component structure
    delete c;
}



#endif /// #ifdef COSIDE_INCLUDE_IMPLEMENTATION

} /// end namespace pll_namespace

/// remove temporary defines
#undef DONT_INCLUDE_HIERARCHIC_COMPONENTS
#undef COSIDE_INCLUDE_IMPLEMENTATION


