////////////////////////////////////////////////////////////////////////////////
//
// @copyright COSEDA Technologies GmbH. All rights reserved.
//            (customizable in sca_modules.dtd)
//
////////////////////////////////////////////////////////////////////////////////
//
// this file was generated by 'sca_xml2scsimctrl_tb.xsl' StyleSheet
//
////////////////////////////////////////////////////////////////////////////////
//
//   Version Id       : $Id$
//   Author           : SCSimCtrl
//   Last Modified By : $Author$
//   Last Modified On : $Date$
//
////////////////////////////////////////////////////////////////////////////////

/** ============================ DO NOT EDIT THIS FILE! ========================
 *  = This file was automatically generated from an COSIDE schematic/primitive.
 *  = (recreate via: "div_tb.scaml")
 *  ============================================================================
 */

// enable to access module components within the hierarchy
// #define ACCESS_MODULE_COMPONENTS_HIERARCHIC

#include <systemc.h>
#include <systemc-ams.h>
#include "../libpll/div_tb.h"

// include COSIDE test bench utilities
#include "sca_basic_libraries/coside_utilities.h"
#include "sca_basic_libraries/coside_libraries.h"

#include <cstdlib>

int sc_main(int argc, char* argv[])
{
    sc_core::sc_set_time_resolution(1.0, sc_core::SC_FS);

    //////////////////////////////////////////////////////////////////////////////
    // define DUT parameter structure                                           //
    //////////////////////////////////////////////////////////////////////////////

    div_tb::params p_div_tb;
    p_div_tb.fin = 1e3;  /* Input frequency */
    p_div_tb.n = 2;  /* Division ration */
    p_div_tb.vpeak = 3.3;  /* Maximum voltage */
    p_div_tb.vcm = 1.65;  /* Common mode voltage */

    //////////////////////////////////////////////////////////////////////////////
    // command line reader                                                      //
    // default options:                                                         //
    //                  --help              - list all parameter and usage      //
    //                  --sim_time          - start testbench                   //
    //////////////////////////////////////////////////////////////////////////////
    sc_core::sc_time sim_time = sc_core::sc_max_time();
    
    cmd_line_reader::config c_coside_clr;
    c_coside_clr.verbose = true;
    cmd_line_reader* i_coside_clr;
    i_coside_clr = new cmd_line_reader(argc, argv, c_coside_clr);
      i_coside_clr -> add("sim_time", sim_time, "simulation time in seconds");
      i_coside_clr -> add("fin", p_div_tb.fin, "Input frequency");
      i_coside_clr -> add("n", p_div_tb.n, "Division ration");
      i_coside_clr -> add("vpeak", p_div_tb.vpeak, "Maximum voltage");
      i_coside_clr -> add("vcm", p_div_tb.vcm, "Common mode voltage");
      i_coside_clr -> read();

    //////////////////////////////////////////////////////////////////////////////
    // signal definition                                                        //
    //////////////////////////////////////////////////////////////////////////////


    //////////////////////////////////////////////////////////////////////////////
    // DUT - device under test                                                  //
    //////////////////////////////////////////////////////////////////////////////

    div_tb* i_div_tb;
    i_div_tb = new div_tb("i_div_tb", p_div_tb);

    //////////////////////////////////////////////////////////////////////////////
    // time domain simulation                                                   //
    //////////////////////////////////////////////////////////////////////////////
    sc_core::sc_start(sim_time-sc_core::sc_time_stamp(), sc_core::SC_EXIT_ON_STARVATION);

    SC_REPORT_INFO("sc_main", "time domain simulation complete");

    SC_REPORT_INFO("sc_main", "\n"
      "//////////////////////////////////////////////////////////////////////////////\n"
      "//                            Simulation finished                           //\n"
      "//////////////////////////////////////////////////////////////////////////////");

    SC_REPORT_INFO("sc_main", ("simulation stopped at " + sc_core::sc_time_stamp().to_string()).c_str());

    // clean-up
    delete i_div_tb;
    delete i_coside_clr;

    return EXIT_SUCCESS;
}
