/////////////////////////////////////////////////////////////////////////////////
///
/// @copyright COSEDA Technologies GmbH. All rights reserved.		
///            (customizable in sca_modules.dtd)		
///
/////////////////////////////////////////////////////////////////////////////////
//
// Author        : COSIDE(R) netlister
// Tool User     :
// Editors email :
// Created On    :
// Last Modifier : $Author$
// Last Modified : $Date$
//
// SVN Status    : $Id$
// Status        : Unknown, use with caution!
//
////////////////////////////////////////////////////////////////////////////////

#ifndef PLL_LIBPLL_LFILTER_H_
#define PLL_LIBPLL_LFILTER_H_

/** ============================ DO NOT EDIT THIS FILE! ========================
 *  = This file was automatically generated from an COSIDE schematic.
 *  = (recreate via: "lfilter.scaml")
 *  ============================================================================
 */

#include <systemc>
#include <systemc-ams>

/// user specified includes

/// include sca_basic_libraries utilities
#include <sca_basic_libraries/utilities/sca_basic_lib_utilities.h>


namespace pll_namespace
{

SC_MODULE(lfilter)
{

	/// ports
	sca_tdf::sca_in<double	 >	icp;	/** input control current */
	sca_tdf::sca_out<double	 >	vcp;	/** voltage of the input node (charge pump) */
	sca_tdf::sca_out<double	 >	vctrl;	/** voltage of the output (=v_cp for the 2nd order filter) */


    /// parameters
    struct params
    {
        double c1; /** C1 value in Farads */
        double r2; /** R1 value in Ohm */
        double c2; /** C2 value in Farads */
        double r3; /** R3 value in Ohm */
        double c3; /** C3 value in Farads */
        bool third_order; /** Order selection flag (false to 2nd order, true for 3rd) */

        params()
        {
            c1 = 1e-12;
            r2 = 1;
            c2 = 1e-12;
            r3 = 1.0;
            c3 = 1e-12;
            third_order = false;
        }
    } p;

    void architecture();

    lfilter(sc_core::sc_module_name, const params& pa = params());

    virtual ~lfilter();

    struct components;
      components* c;
      components* operator -> () { return c; }

    private:

};



} /// end namespace pll_namespace
using pll_namespace::lfilter;



#endif

#if defined(ACCESS_MODULE_COMPONENTS) || defined(ACCESS_MODULE_COMPONENTS_HIERARCHIC)
#ifndef ACCESS_MODULE_COMPONENTS_HIERARCHIC
#undef  ACCESS_MODULE_COMPONENTS
#endif
#ifndef PLL_LIBPLL_LFILTER_CPP_
#define PLL_LIBPLL_LFILTER_CPP_
#include "lfilter.cpp"
#endif
#endif

