////////////////////////////////////////////////////////////////////////////////
//
// @copyright COSEDA Technologies GmbH. All rights reserved.
//            (customizable in sca_modules.dtd)
//
////////////////////////////////////////////////////////////////////////////////
//
// this file was generated by 'sca_xml2scsimctrl_tb.xsl' StyleSheet
//
////////////////////////////////////////////////////////////////////////////////
//
//   Version Id       : $Id$
//   Author           : SCSimCtrl
//   Last Modified By : $Author$
//   Last Modified On : $Date$
//
////////////////////////////////////////////////////////////////////////////////

/** ============================ DO NOT EDIT THIS FILE! ========================
 *  = This file was automatically generated from an COSIDE schematic/primitive.
 *  = (recreate via: "psd_tb.scaml")
 *  ============================================================================
 */

// enable to access module components within the hierarchy
// #define ACCESS_MODULE_COMPONENTS_HIERARCHIC

#include <systemc.h>
#include <systemc-ams.h>
#include "../libpll/psd_tb.h"

// include COSIDE test bench utilities
#include "sca_basic_libraries/coside_utilities.h"
#include "sca_basic_libraries/coside_libraries.h"

#include <cstdlib>

int sc_main(int argc, char* argv[])
{
    sc_core::sc_set_time_resolution(1.0, sc_core::SC_FS);

    //////////////////////////////////////////////////////////////////////////////
    // define DUT parameter structure                                           //
    //////////////////////////////////////////////////////////////////////////////

    psd_tb::params p_psd_tb;
    p_psd_tb.ref_clk_period = 1e-6;  /* Reference clock period */
    p_psd_tb.div_clk_period = 1.01e-6;  /* Divided clock period */
    p_psd_tb.delay = 10e-9;  /* Phase detector delay */

    //////////////////////////////////////////////////////////////////////////////
    // command line reader                                                      //
    // default options:                                                         //
    //                  --help              - list all parameter and usage      //
    //                  --sim_time          - start testbench                   //
    //////////////////////////////////////////////////////////////////////////////
    sc_core::sc_time sim_time = sc_core::sc_max_time();
    
    cmd_line_reader::config c_coside_clr;
    c_coside_clr.verbose = true;
    cmd_line_reader* i_coside_clr;
    i_coside_clr = new cmd_line_reader(argc, argv, c_coside_clr);
      i_coside_clr -> add("sim_time", sim_time, "simulation time in seconds");
      i_coside_clr -> add("ref_clk_period", p_psd_tb.ref_clk_period, "Reference clock period");
      i_coside_clr -> add("div_clk_period", p_psd_tb.div_clk_period, "Divided clock period");
      i_coside_clr -> add("delay", p_psd_tb.delay, "Phase detector delay");
      i_coside_clr -> read();

    //////////////////////////////////////////////////////////////////////////////
    // signal definition                                                        //
    //////////////////////////////////////////////////////////////////////////////


    //////////////////////////////////////////////////////////////////////////////
    // DUT - device under test                                                  //
    //////////////////////////////////////////////////////////////////////////////

    psd_tb* i_psd_tb;
    i_psd_tb = new psd_tb("i_psd_tb", p_psd_tb);

    //////////////////////////////////////////////////////////////////////////////
    // time domain simulation                                                   //
    //////////////////////////////////////////////////////////////////////////////
    sc_core::sc_start(sim_time-sc_core::sc_time_stamp(), sc_core::SC_EXIT_ON_STARVATION);

    SC_REPORT_INFO("sc_main", "time domain simulation complete");

    SC_REPORT_INFO("sc_main", "\n"
      "//////////////////////////////////////////////////////////////////////////////\n"
      "//                            Simulation finished                           //\n"
      "//////////////////////////////////////////////////////////////////////////////");

    SC_REPORT_INFO("sc_main", ("simulation stopped at " + sc_core::sc_time_stamp().to_string()).c_str());

    // clean-up
    delete i_psd_tb;
    delete i_coside_clr;

    return EXIT_SUCCESS;
}
