////////////////////////////////////////////////////////////////////////////////
//
// @copyright COSEDA Technologies GmbH. All rights reserved.
//            (customizable in sca_modules.dtd)
//
////////////////////////////////////////////////////////////////////////////////
//
// @project      pll
//
// @library      libpll
//
// @file         vco
//
// @brief
//      /** Voltage Controlled Oscillator */
//
// DESCRIPTION OF PORTS:           (please see header)
// DESCRIPTION OF PARAMETERS:      (please see header)
//
// this file was generated by 'sca_xml2cpp.xsl' StyleSheet
//
////////////////////////////////////////////////////////////////////////////////
//
// Version Id       : $Id$
// @author          : Am?rico Dias
// Last Modified By : $Author$
// Last Modified On : $Date$
//
////////////////////////////////////////////////////////////////////////////////

#ifndef PLL_LIBPLL_VCO_H_
#include "vco.h"
#define COSIDE_INCLUDE_IMPLEMENTATION
#endif

// adds SystemC namespaces for user convenience
#include <systemc-ams.h>

namespace pll_namespace
{

//-------------------------------------------------------------------//
// states                                                            //
//-------------------------------------------------------------------//
struct vco::states
{

    states(const params& p)
    {
    }

};
//-------------------------------------------------------------------//

#ifdef COSIDE_INCLUDE_IMPLEMENTATION


//-------------------------------------------------------------------//
vco::states& vco::create_states(const params& pa) { return *(new states(pa)); }
//-------------------------------------------------------------------//


//////////////////////////////////////////////
// method called by constructor             //
//////////////////////////////////////////////
void vco::construct()
{

}

//////////////////////////////////////////////
// destructor                               //
//////////////////////////////////////////////
vco::~vco()
{

    delete &s;
}

//////////////////////////////////////////////
// method processing                        //
//////////////////////////////////////////////
void vco::processing()
{
	double frequency = p.kvo*vctrl.read() + p.fmin;
	double time = sc_time_stamp().to_seconds();

	double phi=this->idtmod(frequency, time);

	fout.write((double)(p.vcm+p.vcm*sin(phi)));
	freq.write(frequency);
}

//////////////////////////////////////////////
// method called by set_attributes          //
//////////////////////////////////////////////
void vco::set_attributes_cpp()
{
	fout.set_timestep(p.tstep,sc_core::SC_SEC);
}


//////////////////////////////////////////////
// USER_METHOD idtmod
//////////////////////////////////////////////
double vco::idtmod(double frequency, double time)
{
	static double time0 = 0;
	static double phi0 = 0;

	double T { 1 / frequency };
	double phi = phi0 + 2*M_PI*(time-time0)/T;

	phi0 = phi = fmod(phi, 2*M_PI);		// Limit the phase between 0 and 2*pi
	time0 = time;						// Save the time for the next integration

	return phi;
}


#endif // #ifdef COSIDE_INCLUDE_IMPLEMENTATION

}  // end namespace pll_namespace

// clear temporary defines
#undef COSIDE_INCLUDE_IMPLEMENTATION
