/////////////////////////////////////////////////////////////////////////////////
///
/// @copyright COSEDA Technologies GmbH. All rights reserved.		
///            (customizable in sca_modules.dtd)		
///
/////////////////////////////////////////////////////////////////////////////////
//
// Author        : COSIDE(R) netlister
// Tool User     :
// Editors email :
// Created On    :
// Last Modifier : $Author$
// Last Modified : $Date$
//
// SVN Status    : $Id$
// Status        : Unknown, use with caution!
//
////////////////////////////////////////////////////////////////////////////////

#ifndef PLL_LIBPLL_VCO_TB_H_
#define PLL_LIBPLL_VCO_TB_H_

/** ============================ DO NOT EDIT THIS FILE! ========================
 *  = This file was automatically generated from an COSIDE schematic.
 *  = (recreate via: "vco_tb.scaml")
 *  ============================================================================
 */

#include <systemc>
#include <systemc-ams>

/// user specified includes

/// include sca_basic_libraries utilities
#include <sca_basic_libraries/utilities/sca_basic_lib_utilities.h>


namespace pll_namespace
{

SC_MODULE(vco_tb)
{

	/// ports


    /// parameters
    struct params
    {
        double vdd; /** Voltage supply */
        double kvo; /** VCO gain */
        double fmin; /** Minimum frequency */
        double tstep; /** step time */
        double tstop; /** stop time */

        params()
        {
            vdd = 3.3;
            kvo = 36.363636e6;
            fmin = 2.39e9;
            tstep = 40e-12;
            tstop = 200e-9;
        }
    } p;

    void architecture();

    vco_tb(sc_core::sc_module_name, const params& pa = params());

    virtual ~vco_tb();

    struct components;
      components* c;
      components* operator -> () { return c; }

    private:

};



} /// end namespace pll_namespace
using pll_namespace::vco_tb;



#endif

#if defined(ACCESS_MODULE_COMPONENTS) || defined(ACCESS_MODULE_COMPONENTS_HIERARCHIC)
#ifndef ACCESS_MODULE_COMPONENTS_HIERARCHIC
#undef  ACCESS_MODULE_COMPONENTS
#endif
#ifndef PLL_LIBPLL_VCO_TB_CPP_
#define PLL_LIBPLL_VCO_TB_CPP_
#include "vco_tb.cpp"
#endif
#endif

